@echo off
rem *** Author: T. Wittrock, RZ Uni Kiel ***

setlocal enableextensions
if errorlevel 1 goto NoExtensions

%~d0
cd "%~p0"

for %%i in (w2k w2k3 wxp) do (if /i "%1"=="%%i" goto Valid1)
goto InValid1
:Valid1
for %%i in (deu enu) do (if /i "%2"=="%%i" goto Valid2)
goto InValid2
:Valid2
if "%3"=="" goto NoMoreParam
if /i "%3"=="/scheduled" set SKIPIE=1
if /i "%3"=="/skipiso" set SKIPISO=1
if /i "%3"=="/proxy" (
  set http_proxy=%4
  shift /3
)
shift /3
goto Valid2
:NoMoreParam

if "%TEMP%"=="" goto NoTemp
if not exist %TEMP%\nul goto NoTempDir

if not exist ..\bin\wget.exe goto NoWGet
if not exist %SystemRoot%\system32\expand.exe goto NoExpand

rem *** Copy Microsoft registry console tool ***
echo Copying Microsoft registry console tool...
if exist ..\client\bin\reg.exe goto SkipRegExe
if not exist ..\client\bin\nul md ..\client\bin
if exist %SystemRoot%\system32\reg.exe (copy %SystemRoot%\system32\reg.exe ..\client\bin) else goto NoRegExe
:SkipRegExe

rem *** Download Microsoft ifmember tool ***
echo Downloading Microsoft ifmember tool...
if not exist ..\client\bin\ifmember.exe (
  if not exist ..\bin\msiextract.exe goto NoMSIExtract
  ..\bin\wget.exe -N -i ..\static\StaticDownloadLink-ifmember.txt -P "%TEMP%\ifmember"
  if errorlevel 1 goto DownloadError
  %TEMP%\ifmember\IfMember_Setup.exe /T:"%TEMP%\ifmember" /C
  copy ..\bin\msiextract.exe "%TEMP%\ifmember" 
  pushd "%TEMP%\ifmember"
  msiextract.exe ifmember.Msi
  popd
  move "%TEMP%\ifmember\ifmember.exe" ..\client\bin
  rd /S /Q "%TEMP%\ifmember"
)

rem *** Download Microsoft XSL processor frontend ***
echo Downloading Microsoft XSL processor frontend...
..\bin\wget.exe -N -i ..\static\StaticDownloadLink-msxsl.txt -P ..\bin
if errorlevel 1 goto DownloadError

rem *** Download statics for WSUS functionality ***
echo Downloading statics for WSUS functionality...
..\bin\wget.exe -N -i ..\static\StaticDownloadLinks-wsus.txt -P ..\client\wsus
if errorlevel 1 goto DownloadError

rem *** Download latest Microsoft Installer ***
echo Downloading latest Microsoft Installer...
..\bin\wget.exe -N -i ..\static\StaticDownloadLinks-msi.txt -P ..\client\msi
if errorlevel 1 goto DownloadError

rem *** Extract update catalog file package.xml ***
echo Extracting update catalog file package.xml...
if exist %TEMP%\package.cab del %TEMP%\package.cab
if exist %TEMP%\package.xml del %TEMP%\package.xml
%SystemRoot%\system32\expand.exe ..\client\wsus\wsusscan.cab -f:package.cab %TEMP%\package.cab
%SystemRoot%\system32\expand.exe %TEMP%\package.cab -f:package.xml %TEMP%
del %TEMP%\package.cab

rem *** Determine update urls for %1 %2 ***
echo Determining update urls for %1 %2...
if exist %TEMP%\DownloadLinks-%1-x86-%2.txt del %TEMP%\DownloadLinks-%1-x86-%2.txt
..\bin\msxsl.exe %TEMP%\package.xml ..\xslt\ExtractDownloadLinks-%1-x86-%2.xsl -o %TEMP%\DownloadLinks-%1-x86-%2.txt
if errorlevel 1 goto DownloadError

rem *** Determine update urls for win %2 ***
echo Determining update urls for win %2...
if exist %TEMP%\DownloadLinks-win-x86-%2.txt del %TEMP%\DownloadLinks-win-x86-%2.txt
..\bin\msxsl.exe %TEMP%\package.xml ..\xslt\ExtractDownloadLinks-win-x86-%2.xsl -o %TEMP%\DownloadLinks-win-x86-%2.txt
if errorlevel 1 goto DownloadError

del %TEMP%\package.xml

rem *** Download statics for %1 %2 ***
echo Downloading statics for %1 %2...
..\bin\wget.exe -N -i ..\static\StaticDownloadLinks-%1-%2.txt -P ..\client\%1\%2
if errorlevel 1 goto DownloadError

rem *** Download statics for win %2 ***
echo Downloading statics for win %2...
..\bin\wget.exe -N -i ..\static\StaticDownloadLinks-win-%2.txt -P ..\client\win\%2
if errorlevel 1 goto DownloadError

if "%SKIPIE%"=="1" goto SkipIE
rem *** Download statics for IE %2 ***
if /i "%1"=="w2k" (
  rem *** Required only for w2k ***
  echo Downloading statics for IE %2...
  ..\bin\wget.exe -N -i ..\static\StaticDownloadLinks-ie6-%2.txt -P ..\client\win\%2\ie6setup
  if errorlevel 1 goto DownloadError
  rem *** ie6setup.exe would otherwise delete installation files for other languages ***
  if /i "%2"=="deu" (if exist ..\client\win\enu\ie6setup\nul ren ..\client\win\enu\ie6setup _ie6setup_)
  if /i "%2"=="enu" (if exist ..\client\win\deu\ie6setup\nul ren ..\client\win\deu\ie6setup _ie6setup_)
  pushd ..\client\win\%2\ie6setup
  ..\..\..\..\cmd\ie6download.exe %2
  if errorlevel 1 (
    popd
    if /i "%2"=="deu" (if exist ..\client\win\enu\_ie6setup_\nul ren ..\client\win\enu\_ie6setup_ ie6setup)
    if /i "%2"=="enu" (if exist ..\client\win\deu\_ie6setup_\nul ren ..\client\win\deu\_ie6setup_ ie6setup)
    goto DownloadError
  ) else (
    popd
    if /i "%2"=="deu" (if exist ..\client\win\enu\_ie6setup_\nul ren ..\client\win\enu\_ie6setup_ ie6setup)
    if /i "%2"=="enu" (if exist ..\client\win\deu\_ie6setup_\nul ren ..\client\win\deu\_ie6setup_ ie6setup)
  )
)
:SkipIE

rem *** Download updates for %1 %2 ***
echo Downloading updates for %1 %2...
if not exist ..\client\%1\%2\nul md ..\client\%1\%2
..\bin\wget.exe -nv -N -i %TEMP%\DownloadLinks-%1-x86-%2.txt -P ..\client\%1\%2
if errorlevel 1 goto DownloadError
del %TEMP%\DownloadLinks-%1-x86-%2.txt

rem *** Download updates for win %2 ***
echo Downloading updates for win %2...
if not exist ..\client\win\%2\nul md ..\client\win\%2
..\bin\wget.exe -nv -N -i %TEMP%\DownloadLinks-win-x86-%2.txt -P ..\client\win\%2
if errorlevel 1 goto DownloadError
del %TEMP%\DownloadLinks-win-x86-%2.txt

REM *** Remind build date ***
echo Reminding build date...
date /T > ..\client\builddate.txt

rem *** Create ISO image ***
if "%SKIPISO%"=="1" goto SkipIso
call CreateISOImage.cmd %1 %2
:SkipIso
goto EoF

:NoExtensions
echo.
echo ERROR: No command extensions available.
echo.
goto Error

:InValid1
echo.
echo ERROR: Invalid parameter %1
echo Usage: %~n0 {w2k ^| w2k3 ^| wxp} {deu ^| enu} [/scheduled] [/skipiso] [/proxy http://server:port]
echo.
goto Error

:InValid2
echo.
echo ERROR: Invalid parameter %2
echo Usage: %~n0 {w2k ^| w2k3 ^| wxp} {deu ^| enu} [/scheduled] [/skipiso] [/proxy http://server:port]
echo.
goto Error

:NoTemp
echo.
echo ERROR: Environment variable TEMP not set.
echo.
goto Error

:NoTempDir
echo.
echo ERROR: Directory %TEMP% not found.
echo.
goto Error

:NoWGet
echo.
echo ERROR: Utility ..\bin\wget.exe not found.
echo.
goto Error

:NoExpand
echo.
echo ERROR: Utility %SystemRoot%\system32\expand.exe not found.
echo.
goto Error

:NoMSIExtract
echo.
echo ERROR: Utility ..\bin\msiextract.exe not found.
echo.
goto Error

:NoRegExe
echo.
echo ERROR: Utility %SystemRoot%\system32\reg.exe not found.
echo If you run Windows 2000, try to manually extract this file out of
echo the \SUPPORT\TOOLS\SUPPORT.CAB file on your installation CD and
echo copy it to the directory ..\client\bin.
echo.
goto Error

:DownloadError
echo.
echo ERROR: Download failure.
echo.
goto Error

:Error
endlocal
pause
SignalError.exe
exit

:EoF
endlocal
