@echo off
rem *** Author: T. Wittrock, RZ Uni Kiel ***

setlocal enableextensions
if errorlevel 1 goto NoExtensions

if /i "%1"=="/scheduled" set SKIPIE=1

set CSCRIPT_PATH=%SystemRoot%\system32\cscript.exe
if not exist %CSCRIPT_PATH% goto NoCScript
if not exist %~dps0..\bin\wget.exe goto NoWGet

rem *** Copy Microsoft registry console tool ***
echo Copying Microsoft registry console tool...
if exist %~dps0..\client\bin\reg.exe goto SkipRegExe
if not exist %~dps0..\client\bin\nul md %~dps0..\client\bin
if exist %SystemRoot%\system32\reg.exe (copy %SystemRoot%\system32\reg.exe %~dps0..\client\bin) else goto NoRegExe
:SkipRegExe

rem *** Download statics ***
echo Downloading statics...
for %%i in (msi wsus) do (
  %~dps0..\bin\wget.exe -N -i %~dps0..\static\StaticDownloadLinks-%%i.txt -P %~dps0..\client\%%i
  if errorlevel 1 goto DownloadError
)
if not exist %~dps0..\client\bin\ifmember.exe (
  if not exist %~dps0..\bin\msiextract.exe goto NoMSIExtract
  %~dps0..\bin\wget.exe -N -i %~dps0..\static\StaticDownloadLink-ifmember.txt -P %~dps0..\client\bin\ifmember
  if errorlevel 1 goto DownloadError
  %~dps0..\client\bin\ifmember\IfMember_Setup.exe /T:%~dps0..\client\bin\ifmember /C
  pushd %~dps0..\client\bin\ifmember
  %~dps0..\bin\msiextract.exe ifmember.Msi
  move ifmember.exe ..
  popd
  rd /S /Q %~dps0..\client\bin\ifmember
)
for %%i in (w2k wxp w2k3 win) do (
  for %%j in (deu enu) do (
    %~dps0..\bin\wget.exe -N -i %~dps0..\static\StaticDownloadLinks-%%i-%%j.txt -P %~dps0..\src\%%i\%%j
    if errorlevel 1 goto DownloadError
  )
)
if "%SKIPIE%"=="1" goto SkipIE
rem *** Download statics for IE ***
for %%j in (deu enu) do (
  %~dps0..\bin\wget.exe -N -i %~dps0..\static\StaticDownloadLinks-ie6-%%j.txt -P %~dps0..\src\win\%%j\ie6setup
  if errorlevel 1 goto DownloadError
  rem *** ie6setup.exe would otherwise delete installation files for other languages ***
  if /i "%%j"=="deu" (if exist %~dps0..\src\win\enu\ie6setup\nul ren %~dps0..\src\win\enu\ie6setup _ie6setup_)
  if /i "%%j"=="enu" (if exist %~dps0..\src\win\deu\ie6setup\nul ren %~dps0..\src\win\deu\ie6setup _ie6setup_)
  pushd %~dps0..\src\win\%%j\ie6setup
  %~dps0ie6download.exe %%j
  if errorlevel 1 (
    popd
    if /i "%%j"=="deu" (if exist %~dps0..\src\win\enu\_ie6setup_\nul ren %~dps0..\src\win\enu\_ie6setup_ ie6setup)
    if /i "%%j"=="enu" (if exist %~dps0..\src\win\deu\_ie6setup_\nul ren %~dps0..\src\win\deu\_ie6setup_ ie6setup)
    goto DownloadError
  ) else (
    popd
    if /i "%%j"=="deu" (if exist %~dps0..\src\win\enu\_ie6setup_\nul ren %~dps0..\src\win\enu\_ie6setup_ ie6setup)
    if /i "%%j"=="enu" (if exist %~dps0..\src\win\deu\_ie6setup_\nul ren %~dps0..\src\win\deu\_ie6setup_ ie6setup)
  )
)
:SkipIE

rem *** Extract updates ***
echo Extracting updates...
%CSCRIPT_PATH% //Nologo ExtractUpdatesFromWSUS.vbs

rem *** Copy statics ***
echo Copying statics...
xcopy %~dps0..\src\*.* %~dps0..\client\*.* /S /Y

REM *** Remind build date ***
echo Reminding build date...
date /T > %~dps0..\client\builddate.txt

rem *** Create ISO images ***
for %%i in (w2k wxp w2k3) do (
  for %%j in (deu enu) do (
    call %~dps0CreateISOImage.cmd %%i %%j
  )
)
call %~dps0CreateISOImage.cmd all

rem *** Clean client tree ***
echo Cleaning client tree...
for %%i in (w2k wxp w2k3 win) do rd /S /Q %~dps0..\client\%%i 

goto EoF

:NoExtensions
echo.
echo ERROR: No command extensions available.
echo.
goto EoF

:NoCScript
echo.
echo ERROR: VBScript interpreter %CSCRIPT_PATH% not found.
echo.
goto EoF

:NoWGet
echo.
echo ERROR: Utility %~dps0..\bin\wget.exe not found.
echo.
goto EoF

:NoMSIExtract
echo.
echo ERROR: Utility %~dps0..\bin\msiextract.exe not found.
echo.
goto EoF

:NoRegExe
echo.
echo ERROR: Utility %SystemRoot%\system32\reg.exe not found.
echo If you run Windows 2000, try to manually extract this file out of
echo the \SUPPORT\TOOLS\SUPPORT.CAB file on your installation CD and
echo copy it to the directory %~dps0..\client\bin.
echo.
goto EoF

:DownloadError
echo.
echo ERROR: Download failure.
echo.
goto EoF

:EoF
endlocal
